﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Contract;

namespace Extensions2
{
    [ExportWidget(Area = WidgetArea.TopArea, Name = "Anonyme", Version = 1)]
    public partial class Widget4 : UserControl, IWidgetBehavior, INotifyPropertyChanged
    {
        public Widget4()
        {
            InitializeComponent();
        }

        #region IWidgetBehavior Members

        private bool isActive;
        public bool IsActive
        {
            get { return isActive; }
            set
            {
                if (isActive == value) return;
                isActive = value;
                doPropertyChanged("IsActive");
            }
        }

        private bool isSelected;
        public bool IsSelected
        {
            get { return isSelected; }
            set
            {
                if (isSelected == value) return;
                isSelected = value;
                doPropertyChanged("IsSelected");
            }
        }

        private string widgetName;
        public string WidgetName
        {
            get { return widgetName; }
            set
            {
                if (widgetName == value) return;
                widgetName = value;
                doPropertyChanged("WidgetName");
            }
        }

        private WidgetArea area;
        public WidgetArea Area
        {
            get { return area; }
            set
            {
                if (area == value) return;
                area = value;
                doPropertyChanged("Area");
            }
        }


        private int version;
        public int Version
        {
            get { return version; }
            set
            {
                if (version == value) return;
                version = value;
                doPropertyChanged("Version");
            }
        }
        #endregion



        #region INotifyPropertyChanged Members

        private void doPropertyChanged(string property)
        {
            var p = PropertyChanged;
            if (p == null) return;
            p(this, new PropertyChangedEventArgs(property));
        }

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
