﻿using System;
using System.ComponentModel.Composition;
using System.Windows;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;

namespace Shell
{
    [Export]
    public class Widget1ViewModel : ViewModelBase
    {
        public Widget1ViewModel()
        {
            LoadExtensions = new RelayCommand(() => Service.AddXap("extensions.xap",
                                                                   args =>
                                                                   {
                                                                       if (args.Error != null)
                                                                           MessageBox.Show(
                                                                                   "Error loading extensions"
                                                                                   + Environment.NewLine
                                                                                   + args.Error.Message);
                                                                   }));
        }

        [Import(typeof(IDeploymentService))]
        public IDeploymentService Service { get; set; }

        public ICommand LoadExtensions { get; private set; }

    }
}
