﻿using System;
using System.ComponentModel;
using System.ComponentModel.Composition;
using System.Windows;
using System.Windows.Controls;
using Contract;

namespace Shell
{

    [ExportWidget(Area = WidgetArea.TopArea, Name = "Local Widget", Version = 2)]
    public partial class Widget1 : UserControl, IWidgetBehavior, INotifyPropertyChanged
    {
        public Widget1()
        {
            InitializeComponent();
        }

        [Import]
        public Widget1ViewModel ViewModel
        {
            get { return (Widget1ViewModel)DataContext; }
            set { DataContext = value; }
        }


        #region IWidgetBehavior Members

        private bool isActive;
        public bool IsActive
        {
            get { return isActive; }
            set
            {
                if (isActive == value) return;
                isActive = value;
                doPropertyChanged("IsActive");
            }
        }

        private bool isSelected;
        public bool IsSelected
        {
            get { return isSelected; }
            set
            {
                if (isSelected == value) return;
                isSelected = value;
                doPropertyChanged("IsSelected");
            }
        }

        private string widgetName;
        public string WidgetName
        {
            get { return widgetName; }
            set
            {
                if (widgetName == value) return;
                widgetName = value;
                doPropertyChanged("WidgetName");
            }
        }

        private WidgetArea area;
        public WidgetArea Area
        {
            get { return area; }
            set
            {
                if (area == value) return;
                area = value;
                doPropertyChanged("Area");
            }
        }

       
        private int version;
        public int Version
        {
            get { return version; }
            set
            {
                if (version == value) return;
                version = value;
                doPropertyChanged("Version");
            }
        }

        #endregion



        #region INotifyPropertyChanged Members

        private void doPropertyChanged(string property)
        {
            var p = PropertyChanged;
            if (p == null) return;
            p(this, new PropertyChangedEventArgs(property));
        }

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
