﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            CompositionInitializer.SatisfyImports(this);
            displayModules();

        }

        [ImportMany]
       // public Lazy<UserControl,IDictionary<string, object>>[] Modules { get; set; }
        public IEnumerable<Lazy<UserControl,IDictionary<string, object>>> Modules { get; set; }

        private void displayModules()
        {
            foreach (var control in Modules)
            {
                var dock = (control.Metadata.ContainsKey("Location"))
                                   ? (Dock) control.Metadata["Location"]
                                   : Dock.Bottom;

                control.Value.SetValue(DockPanel.DockProperty, dock);
                MainDock.Children.Add(control.Value);
            }
        }
    }
}
