﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverlightApplication1.Contract;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            CompositionInitializer.SatisfyImports(this);
            displayModules();

        }

        [ImportMany]
        // public Lazy<UserControl,IDictionary<string, object>>[] Modules { get; set; }
        public IEnumerable<Lazy<UserControl, IModule>> Modules { get; set; }

        private void displayModules()
        {
            foreach (var control in Modules)
            {
                var dock = control.Metadata.Location;
                var colorName = control.Metadata.Background;
                var color = getThisColor(colorName);
                control.Value.SetValue(DockPanel.DockProperty, dock);
                control.Value.Background = new SolidColorBrush(color);
                MainDock.Children.Add(control.Value);
            }
        }

        private Color getThisColor(string colorString)
        {
            var colorType = (typeof(Colors));
            if (colorType.GetProperty(colorString) != null)
            {
                var o = colorType.InvokeMember(colorString, BindingFlags.GetProperty, null, null, null);
                if (o != null) return (Color)o;
            }
            return Colors.Black;
        }
    }
}
